class Broambox {
public:
        char *GetPluginDllPath();
	char s[512]; //temp 
        HINSTANCE h; //boxengine.dll's 
        FARPROC ec;  //boxengine.dll::EC()
	HWND hEditWnd;
	HWND hSlit;
	WNDPROC wpEditProc;
	COLORREF textColor;
	Broambox(HINSTANCE, HWND);
	bool CreateBroambox();
	void DestroyBroambox();
	void PaintBroambox(HDC, LPRECT);
	void SizeBroambox();
	void MoveBroambox(WINDOWPOS*);

	void ReadSettings();
	void ReplaceFont();

	void ShowWindow();
	void ShowWindowAt(int x, int y);
	void HideWindow();

	void EnterSlit();
	void LeaveSlit();
	void UpdateSlit();
	bool InSlit() { return ( inSlit && (hSlit != NULL) ); }
	void ToggleSlitAutoHide(bool);

	void ToggleInSlit() {
		if(hSlit == NULL) return;
		if( InSlit() )
			LeaveSlit();
		else
			EnterSlit();
	}

	void Execute();
	void HistoryPrev();
	void HistoryNext();
	void ResetHistoryIndex(); 

	LRESULT LButtonDown(HWND, UINT, WPARAM, LPARAM);
	LRESULT RButtonDown(HWND, UINT, WPARAM, LPARAM);

	LPCSTR GetAppName() { return "BBZCmdEx"; }
	LPCSTR GetAppAuthor() { return "Konstantin Procic"; }
	LPCSTR GetAppEmail() { return "admin_kostya@mail.ru"; }
	LPCSTR GetAppLink()  { return ""; }
	LPCSTR GetAppVersion() { return "0.1"; }
	LPCSTR GetAppRelease() { return "22 01 2004"; }

	int historyCount;
	int historyIndex;
	char history[512][MAX_LINE_LENGTH];
private:
	HINSTANCE hMainInst;

	HWND hBB4Win;
	HFONT hEditFont;

	bool inSlit;
	bool tempSlit;
	bool isSlitAutoHide;

	StyleItem *mainStyle;
	StyleItem *editStyle;

	Menu *mainMenu, *exampleConfigSubMenu;

	COLORREF mainBackColor, mainBackColorTo;
	COLORREF editBackColor, editBackColorTo;
	COLORREF borderColor;
	bool no8Ball;
	bool noWho;
	int x, y, width, height, bevel, border;
	char fontFace[MAX_PATH];
	int fontHeight;
};
